#1 - 07/21/2021 01:48 PM - Vladimir Tsichevski

Example 4gl:

USING java.io.ByteArrayOutputStream FROM JAVA.

DEFINE VARIABLE bos AS ByteArrayOutputStream.

bos = new ByteArrayOutputStream(10000).

USING java.io.DataOutputStream FROM JAVA.

DEFINE VARIABLE out AS DataOutputStream.

out = new DataOutputStream(bos).

 

Converts to Java as:

   ...

   @LegacySignature(type = Type.VARIABLE, name = "bos")

   jobject<? extends ByteArrayOutputStream> bos = UndoableFactory.jobject(ByteArrayOutputStream.class);

   @LegacySignature(type = Type.VARIABLE, name = "out")

   jobject<? extends DataOutputStream> out = UndoableFactory.jobject(DataOutputStream.class);

   @LegacySignature(type = Type.MAIN, name = "test-java.p")

   public void execute()

   {

      externalProcedure(TestJava.this, new Block((Init) () -> 

      {

         ObjectOps.register(out, bos);

      }, 

      (Body) () -> 

      {

         bos.assign(new java.io.ByteArrayOutputStream(10000));

         out.assign(new java.io.DataOutputStream(bos));

      }));

   }

ByteArrayOutputStream

Note an object of type jobject is passed to new java.io.DataOutputStream(bos) instead of a ByteArrayOutputStream instance. The correct conversion

output here must be new java.io.DataOutputStream(bos.ref()).
#3 - 07/21/2021 02:07 PM - Constantin Asofiei

Please try this patch:

### Eclipse Workspace Patch 1.0

#P p2j

Index: rules/convert/variable_references.rules

===================================================================

--- rules/convert/variable_references.rules    (revision 2943)

+++ rules/convert/variable_references.rules    (working copy)

@@ -901,6 +901,13 @@

                <rule on="false">not(this.indexPos == 1 and parent.type == prog.object_invocation)

                   <action>lastid = closestPeerId</action>

+                  <!-- java variables need a 'ref' if passed as an argument to a Java-style call -->

+                  <rule>parent.type == prog.parameter and 

+                        evalLib("is_java_cls", this)  and

+                        evalLib("is_java_cls", parent.parent.parent)

+                     <action>lastid = createJavaAst(java.method_call, "ref", lastid)</action>

+                  </rule>

+

                   <!-- emit variable/accessor -->

                   <action>createPeerAst(methodType, methodTxt, lastid)</action>

#4 - 07/21/2021 02:13 PM - Vladimir Tsichevski

Constantin Asofiei wrote:

Please try this patch:

[...]

 

It works, thank you! Will you commit the patch?

#5 - 07/21/2021 02:29 PM - Constantin Asofiei

- Status changed from New to WIP

- % Done changed from 0 to 100

- Assignee set to Constantin Asofiei
Fixed in 3821c rev 12697.

#6 - 07/23/2021 05:12 PM - Vladimir Tsichevski

- Status changed from WIP to Review

#7 - 07/26/2021 08:12 AM - Greg Shah

- Status changed from Review to Closed

Powered by TCPDF (www.tcpdf.org)

05/13/2024 3/3

http://www.tcpdf.org

